# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif
%else
%bcond_with repolib
%endif

%define section free

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define maven_version 2.5.1-redhat-1

Name:           opensaml
Version:        2.5.1
Release:        1%{?reltag}%{?dist}.2
Epoch:          0
Summary:        Open Source SAML 1.0, 1.1 and 2.0 implementation
License:        ASL 2.0
Group:          Development/Java

%if %with mead
Source100: org.opensaml-opensaml-2.5.1-redhat-1-sources.zip
Source101: org.opensaml-opensaml-2.5.1-redhat-1-patches.zip
Source102: opensaml-2.5.1-redhat-1-src.tar.gz
Source103: opensaml-2.5.1-redhat-1-sources.jar
Source104: opensaml-2.5.1-redhat-1.jar
Source105: opensaml-2.5.1-redhat-1-bin.tar.gz
Source106: opensaml-2.5.1-redhat-1-bin.zip
Source107: opensaml-2.5.1-redhat-1.pom
Source108: opensaml-2.5.1-redhat-1-javadoc.jar
Source109: opensaml-2.5.1-redhat-1-src.zip
%endif

URL:            http://www.opensaml.org/
%if %without mead
# svn -q export -r 1549 https://svn.shibboleth.net/java-opensaml2/tags/2.4.1 opensaml-2.4.1 && tar czf opensaml-2.4.1.tar.gz opensaml-2.4.1
Source0:        opensaml-2.4.1.tar.gz
Patch0:         opensaml-pom.patch
Patch1:         opensaml-assembly-src.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       openws
#Requires:       velocity
%if %without mead
BuildRequires:  bcprov
BuildRequires:  jboss-parent
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  jboss-servlet-api_3.0_spec
BuildRequires:  junit4
BuildRequires:  openws
BuildRequires:  spring2-core
BuildRequires:  spring2-test
BuildRequires:  velocity
BuildRequires:  xmlunit
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The OpenSAML-J library provides tools to support developers working with the
Security Assertion Markup Language (SAML).

%if %without mead
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export ALT_DEPLOYMENT_REPOSITORY=jboss-releases::default::file://`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/opensaml-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif
%add_to_maven_depmap org.opensaml opensaml %{namedversion} JPP %{name}

# javadoc
%if %without mead
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc doc/*
%endif
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Mar 08 2013 Fernando Nasser <fnasser@redhat.com> - 0:2.5.1-1.redhat_1.2
- Do not require velocity as it is not shipped with the EAP (only velocity-eap6)

* Wed Feb 20 2013 Yong Yang <yyang@redhat.com> - 0:2.5.1-1.redhat_1
- 2.5.1

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.1-10.redhat_3.1
- Rebuild for MD5

* Thu Sep 13 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:2.4.1-9.redhat_3.1
- Fix parent and bom for eap 6.0.1

* Tue Sep 04 2012 Paul Gier <pgier@redhat.com> - 0:2.4.1-8.redhat_2.4
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.1-8.redhat_2.3
- Rebuild unsigned

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.1-8.redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.4.1-8.redhat_1.1
- Rebuild using cache signing

* Mon Jun 25 2012 Martha Benitez <mbenitez@redhat.com> - 0:2.4.1-8.redhat_1
- Build in MEAD

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:2.4.1-7
- rerun vman patch
- add missing bcprov-jdk16 that upstream missed (was through xmltooling)
- add missing commons-httpclient that upstream missed (was through openws)
- remove xml runtime deps
- remove commons-collections and commons-lang
- add docs
- add description (from pom.xml)
- fix repolib file ownership
- fix wrong maven calls
- fix Release
- fix sources file
- javadoc Requires jpackage-utils
- fix Requires

* Fri Oct 25 2011 Yong Yang <yyang@redhat.com> 2.4.1-6_redhat_1
- Build for Werewolf

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 2.4.1-5
- Do not create backup file because the file will be packed into src zip

* Fri Oct 14 2011 Yong Yang <yyang@redhat.com> 2.4.1-4
- Comment dependencySets in assembly src.xml, tar.gz only

* Fri Oct 14 2011 Yong Yang <yyang@redhat.com> 2.4.1-3
- Add more exclude in assembly src.xml

* Fri Oct 14 2011 Yong Yang <yyang@redhat.com> 2.4.1-2
- Add exclusion to assembly src.xml to exclude local repo

* Fri Sep 30 2011 Yong Yang <yyang@redhat.com> 2.4.1-1
- Upgrade to 2.4.1
- Add repolib

* Fri Jul 10 2009 David Walluck <dwalluck@redhat.com> 0:2.2.3-2
- spec cleanup

* Tue Jun 16 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.2.3-1.jpp5
- first release
